#version 430 core

layout(local_size_x = 1,
	local_size_y = 1,
	local_size_z = 1) in;

struct VertexStruct {
	vec3 position;
	vec3 normal;
	vec2 uv;
	uint numberOfNeighbors;
	uint offset;
};

layout(std430, binding = 0) buffer Vertices {
	VertexStruct vertices[];
}verts;

layout(std430, binding = 1) buffer Indices {
	uint indices[];
}indices;

void main(void) {
	uint face = gl_GlobalInvocationID.x;
	uint point1 = indices.indices[face * 3];
	uint point2 = indices.indices[face * 3 + 1];
	uint point3 = indices.indices[face * 3 + 2];

	vec3 faceNormal = normalize(
		verts.vertices[point1].normal + 
		verts.vertices[point2].normal + 
		verts.vertices[point2].normal);

	vec3 crossNormal = normalize(cross(
		verts.vertices[point2].position - verts.vertices[point1].position,
		verts.vertices[point3].position - verts.vertices[point1].position));

	if (dot(faceNormal, crossNormal) < 0.0f) {
		indices.indices[face * 3 + 1] = point3;
		indices.indices[face * 3 + 2] = point2;
	}
}