#version 430 core
out vec4 color;

in vData {
	float ttl;
	float data;
	vec2 texCoords;
	vec3 position;
	vec3 velocity;
} particle;

uniform sampler2D smoke;
uniform sampler2D fire;

#define SMOKE 0
#define FIRE 1

void main()
{
	if (particle.ttl >= 10.0) {
		discard;
	}

	uint texId = uint(particle.data);
	vec4 tint = vec4(0.0, 0.0, 0.0, 0.0);
	if (texId == SMOKE)
		tint = texture(smoke, particle.texCoords)*vec4(0.3, 0.3, 0.3, 1.0)*particle.ttl;
	if (texId == FIRE)
		tint = texture(fire, particle.texCoords)*vec4(1.0, 0.5, 0.0, 1.0)*particle.ttl;

	color = tint;
}
