#version 430 core

layout(location = 0) in vec4 position;
layout(location = 1) in vec4 velocity;
layout(location = 2) in vec2 vertex;
layout(location = 3) in vec2 texCoords;

out vData {
	float ttl;
	float data;
	vec2 texCoords;
	vec3 position;
	vec3 velocity;
} particle;

layout(location = 0) uniform mat4 viewProjection;
layout(location = 1) uniform mat4 transform;
uniform vec3 camRight;
uniform vec3 camUp;

void main()
{
	particle.ttl = position.w;
	particle.texCoords = texCoords;
	particle.velocity = velocity.xyz;
	particle.position = position.xyz;
	particle.data = velocity.w;

	float size = 1.0;
	vec4 posWorld = vec4(position.xyz + camRight*vertex.x*size + camUp*vertex.y*size, 1.0);
    gl_Position = viewProjection * posWorld;
}
